"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenderJavaScriptExperimentalVisitor = void 0;
const visitors_1 = require("../../visitors");
const utils_1 = require("../utils");
const WriteRenderMapVisitor_1 = require("../WriteRenderMapVisitor");
const GetRenderMapVisitor_1 = require("./GetRenderMapVisitor");
class RenderJavaScriptExperimentalVisitor extends visitors_1.BaseThrowVisitor {
    constructor(path, options = {}) {
        super();
        this.path = path;
        this.options = options;
    }
    visitRoot(root) {
        var _a;
        // Delete existing generated folder.
        if ((_a = this.options.deleteFolderBeforeRendering) !== null && _a !== void 0 ? _a : true) {
            (0, utils_1.deleteFolder)(this.path);
        }
        // Render the new files.
        (0, visitors_1.visit)(root, new WriteRenderMapVisitor_1.WriteRenderMapVisitor(new GetRenderMapVisitor_1.GetRenderMapVisitor(this.options), this.path));
    }
}
exports.RenderJavaScriptExperimentalVisitor = RenderJavaScriptExperimentalVisitor;
//# sourceMappingURL=RenderJavaScriptExperimentalVisitor.js.map