"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAccountTypeFragment = void 0;
const shared_1 = require("../../../shared");
const common_1 = require("./common");
const typeWithCodec_1 = require("./typeWithCodec");
function getAccountTypeFragment(accountNode, manifest) {
    const typeWithCodecFragment = accountNode.data.link
        ? (0, common_1.fragment)('')
        : (0, typeWithCodec_1.getTypeWithCodecFragment)(accountNode.data.name, manifest);
    const dataNameFragment = accountNode.data.link
        ? manifest.strictType.clone()
        : (0, common_1.fragment)((0, shared_1.pascalCase)(accountNode.data.name));
    return (0, common_1.fragmentFromTemplate)('accountType.njk', {
        name: (0, shared_1.pascalCase)(accountNode.name),
        dataName: dataNameFragment.render,
        link: accountNode.data.link,
        typeWithCodec: typeWithCodecFragment,
    })
        .mergeImportsWith(dataNameFragment, typeWithCodecFragment)
        .addImports('shared', 'Account');
}
exports.getAccountTypeFragment = getAccountTypeFragment;
//# sourceMappingURL=accountType.js.map