"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInstructionExtraArgsFragment = void 0;
const shared_1 = require("../../../shared");
const common_1 = require("./common");
function getInstructionExtraArgsFragment(instructionNode, extraArgsManifest) {
    if (instructionNode.extraArgs.struct.fields.length === 0 ||
        !!instructionNode.extraArgs.link) {
        return (0, common_1.fragment)('');
    }
    const strictName = (0, shared_1.pascalCase)(instructionNode.extraArgs.name);
    const looseName = `${strictName}Args`;
    return (0, common_1.fragmentFromTemplate)('instructionExtraArgs.njk', {
        looseName,
        manifest: extraArgsManifest,
    }).mergeImportsWith(extraArgsManifest.looseType);
}
exports.getInstructionExtraArgsFragment = getInstructionExtraArgsFragment;
//# sourceMappingURL=instructionExtraArgs.js.map