"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getProgramFragment = void 0;
const shared_1 = require("../../../shared");
const common_1 = require("./common");
function getProgramFragment(programNode) {
    const programAddressConstant = `${(0, shared_1.snakeCase)(programNode.name).toUpperCase()}_PROGRAM_ADDRESS`;
    const programErrorName = `${(0, shared_1.pascalCase)(programNode.name)}ProgramError`;
    const programFragment = (0, common_1.fragmentFromTemplate)('program.njk', {
        program: programNode,
        programAddressConstant,
        programErrorName,
    })
        .addImports('solanaAddresses', ['Base58EncodedAddress'])
        .addImports('shared', ['Program', 'getProgramAddress', 'Context']);
    if (programNode.errors.length > 0) {
        programFragment
            .addImports('shared', ['ProgramWithErrors'])
            .addImports('generatedErrors', [
            programErrorName,
            `${programErrorName}Code`,
            `get${programErrorName}FromCode`,
        ]);
    }
    return programFragment;
}
exports.getProgramFragment = getProgramFragment;
//# sourceMappingURL=program.js.map