"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypeCodecFragment = void 0;
const shared_1 = require("../../../shared");
const common_1 = require("./common");
const typeDecoder_1 = require("./typeDecoder");
const typeEncoder_1 = require("./typeEncoder");
function getTypeCodecFragment(name, manifest, options = {}) {
    var _a, _b, _c;
    const strictName = (0, shared_1.pascalCase)(name);
    const looseName = `${strictName}Args`;
    const context = {
        strictName,
        looseName,
        manifest,
        docs: (_a = options.codecDocs) !== null && _a !== void 0 ? _a : [],
    };
    return (0, common_1.mergeFragments)([
        (0, typeEncoder_1.getTypeEncoderFragment)(name, manifest, (_b = options.encoderDocs) !== null && _b !== void 0 ? _b : []),
        (0, typeDecoder_1.getTypeDecoderFragment)(name, manifest, (_c = options.decoderDocs) !== null && _c !== void 0 ? _c : []),
        (0, common_1.fragmentFromTemplate)('typeCodec.njk', context).addImports('solanaCodecsCore', ['Codec', 'combineCodec']),
    ], (renders) => renders.join('\n\n'));
}
exports.getTypeCodecFragment = getTypeCodecFragment;
//# sourceMappingURL=typeCodec.js.map