import { ConfigureOptions } from 'nunjucks';
import { ImportFrom } from '../../../shared';
import { ImportMap } from '../ImportMap';
import { ContextMap } from '../ContextMap';
export declare function fragment(render: string, imports?: ImportMap): Fragment;
export declare function fragmentFromTemplate(fragmentFile: string, context?: object, options?: ConfigureOptions): Fragment;
export declare function fragmentWithContextMap(render: string, imports?: ImportMap): Fragment & {
    interfaces: ContextMap;
};
export declare function mergeFragments(fragments: Fragment[], mergeRenders: (renders: string[]) => string): Fragment;
export declare class Fragment {
    render: string;
    imports: ImportMap;
    constructor(render: string, imports?: ImportMap);
    setRender(render: string): this;
    mapRender(fn: (render: string) => string): this;
    addImports(module: ImportFrom, imports: string | string[] | Set<string>): this;
    removeImports(module: ImportFrom, imports: string | string[] | Set<string>): this;
    mergeImportsWith(...others: (ImportMap | Fragment)[]): this;
    addImportAlias(module: ImportFrom, name: string, alias: string): this;
    clone(): Fragment;
    toString(): string;
}
